As EAPI 2 support is intended, this requires configuring the build
system to install docs into a temporary location and moving files from
it. Due to the lack of 'dodoc -r', directories inside docdir are
supported only with EAPI 4.

Fixes: https://bugs.gentoo.org/show_bug.cgi?id=350423
---
 eclass/autotools-utils.eclass |   24 +++++++++++++++++++++++-
 1 files changed, 23 insertions(+), 1 deletions(-)

diff --git a/eclass/autotools-utils.eclass b/eclass/autotools-utils.eclass
index 9a13a3a..fcdf219 100644
--- a/eclass/autotools-utils.eclass
+++ b/eclass/autotools-utils.eclass
@@ -392,8 +392,12 @@ autotools-utils_src_configure() {
        [[ -z ${myeconfargs+1} || $(declare -p myeconfargs) == 'declare -a'* ]] 
\
                || die 'autotools-utils.eclass: myeconfargs has to be an array.'
 
+       [[ ${EAPI} == 2 ]] && ! use prefix && EPREFIX=
+
        # Common args
-       local econfargs=()
+       local econfargs=(
+               --docdir="${EPREFIX}/usr/share/doc/${PF}"
+       )
 
        # Handle static-libs found in IUSE, disable them by default
        if in_iuse static-libs; then
@@ -441,6 +445,24 @@ autotools-utils_src_install() {
        emake DESTDIR="${D}" "$@" install || die "emake install failed"
        popd > /dev/null
 
+       # Move docs installed by autotools (in EAPI < 4).
+       if [[ -d ${D}${EPREFIX}/usr/share/doc/${PF} ]]; then
+               if [[ ${EAPI} == [23] ]]; then
+                       mkdir "${T}"/temp-docdir
+                       mv "${D}${EPREFIX}"/usr/share/doc/${PF}/* 
"${T}"/temp-docdir/ \
+                               || die "moving docs to tempdir failed"
+
+                       local f
+                       for f in "${T}"/temp-docdir/*; do
+                               [[ -d ${f} ]] \
+                                       && die "directories in docdir require 
at least EAPI 4"
+                       done
+
+                       dodoc "${T}"/temp-docdir/* || die "docdir dodoc failed"
+                       rm -r "${T}"/temp-docdir || die
+               fi
+       fi
+
        # XXX: support installing them from builddir as well?
        if [[ ${DOCS} ]]; then
                dodoc "${DOCS[@]}" || die "dodoc failed"
-- 
1.7.8.3


Reply via email to